<?php

namespace App\Filament\Imports;

use App\Models\Company;
use Filament\Actions\Imports\Exceptions\RowImportFailedException;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;
use Str;

class CompanyImporter extends Importer
{
    protected static ?string $model = Company::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('name')
                ->requiredMapping()
                ->exampleHeader('Company Name')
                ->example('C.R.I. Pumps Private Limited')
                ->label('Company Name')
                ->rules(['required']),
        ];
    }

    public function resolveRecord(): ?Company
    {
        if (Str::length($this->data['name']) < 0) {
            throw new RowImportFailedException("Company name not found");
        }
        return Company::updateOrCreate([
                'name' => $this->data['name']
            ]
        );
        // return Company::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        // return new Company();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your company import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
